import { BlockPermutation } from "@minecraft/server";
import { Vector } from "../functions";
import { DamageItem } from "../Durability";
const shovelDestroyList = [
    "grass",
    "dirt"
];
export default {
    async executeUse(item, player, block) {
        const tag = item?.getTags()?.find(tag => tag == "break:hoe");
        if (!tag || player.isSneaking)
            return;
        DamageItem(player, item);
        player.playSound('step.gravel');
        for (let deltaX = -1; deltaX <= 1; deltaX++) {
            for (let deltaZ = -1; deltaZ <= 1; deltaZ++) {
                if (!deltaX && !deltaZ)
                    continue; // Saltar la coordenada del bloque 'c'
                const block_ = player.dimension.getBlock(Vector.add(block.location, {
                    x: deltaX,
                    z: deltaZ,
                }));
                if (!block_.hasTag('dirt') && !shovelDestroyList.find(tag => block.hasTag(tag)))
                    continue;
                block_.setPermutation(BlockPermutation.resolve('minecraft:farmland'));
            }
        }
    }
};
