import { BlockPermutation } from "@minecraft/server";
import { Vector, getOrientation, getOrientationX } from "../functions";
import { DamageItem } from "../Durability";
const shovelDestroyList = [
    "grass",
    "gravel",
    "dirt",
    "snow",
    "sand"
];
export default {
    async executeBreak(item, player, location) {
        const tag = item.hasTag('break:shovel');
        if (!tag || player.isSneaking)
            return;
        const { x: bX, y: bY, z: bZ } = location;
        const playerOrientationY = getOrientation(player.getRotation().y);
        const playerOrientationX = getOrientationX(player.getRotation().x);
        for (let deltaY = -1; deltaY <= 1; deltaY += 1) {
            for (let deltaXZ = -1; deltaXZ <= 1; deltaXZ += 1) {
                if (deltaXZ === 0 && deltaY === 0)
                    continue; // Saltar la coordenada del bloque 'c'
                let x, y, z;
                if (playerOrientationX >= 0) {
                    x = bX < 0 ? bX - deltaY : bX + deltaY;
                    y = bY;
                    z = bZ < 0 ? bZ - deltaXZ : bZ + deltaXZ;
                }
                else {
                    x = playerOrientationY >= 3 ? bX : bX < 0 ? bX - deltaXZ : bX + deltaXZ;
                    y = bY < 0 ? bY - deltaY : bY + deltaY;
                    z = playerOrientationY < 3 ? bZ : bZ < 0 ? bZ - deltaXZ : bZ + deltaXZ;
                }
                const block = player.dimension.getBlock({ x, y, z });
                if (!block)
                    continue;
                if (!shovelDestroyList.some(tag => block.hasTag(tag)) && !block.permutation.matches("minecraft:snow"))
                    continue;
                player.runCommand(`setblock ${x} ${y} ${z} air destroy`);
            }
        }
    },
    async executeUse(item, player, block) {
        const tag = item.hasTag('break:shovel');
        if (!tag || player.isSneaking)
            return;
        DamageItem(player, item);
        player.playSound('step.grass');
        for (let deltaX = -1; deltaX <= 1; deltaX++) {
            for (let deltaZ = -1; deltaZ <= 1; deltaZ++) {
                if (!deltaX && !deltaZ)
                    continue; // Saltar la coordenada del bloque 'c'
                const block_ = player.dimension.getBlock(Vector.add(block.location, {
                    x: deltaX,
                    z: deltaZ,
                }));
                if (!block_?.hasTag('dirt'))
                    continue;
                block_.setPermutation(BlockPermutation.resolve('minecraft:grass_path'));
            }
        }
    }
};
