import { beforeEvents, sleep } from "../libraries/utils";
import WoodConvertions from "../libraries/WoodConvertions";
import { DamageItem } from "../libraries/Durability";
beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry: ItemRegistry }) => {
    ItemRegistry.registerCustomComponent('true_tools:tree_capitator', {
        onUseOn: () => { },
        onMineBlock: ({ source, itemStack, block, minedBlockPermutation: broken }) => {
            if (source.isPlayer())
                DamageItem(source, itemStack);
            if (!broken.type.id.endsWith('_log'))
                return;
            const { location, dimension } = block;
            getNearbyBlocks(location, dimension, async function cb(b) {
                if (!b.typeId.endsWith('_log'))
                    return;
                b.destroy();
                await sleep();
                getNearbyBlocks(b, dimension, cb);
            });
        },
    });
});
beforeEvents.itemUseOn.subscribe(async ({ source, itemStack: tool, block }) => {
    if (!tool.getTags().includes('true_tools:stripe_log'))
        return;
    const next = WoodConvertions[block.type.id];
    if (!next)
        return;
    await sleep();
    block.dimension.playSound('use.wood', block.location);
    block.setType(next);
    DamageItem(source, tool);
});
export async function getNearbyBlocks(pos, dimension, cb) {
    for (let x = pos.x - 1; x <= pos.x + 1; x++) {
        for (let y = pos.y - 1; y <= pos.y + 1; y++) {
            for (let z = pos.z - 1; z <= pos.z + 1; z++) {
                try {
                    const block = dimension.getBlock({ x, y, z });
                    if (block)
                        cb(block, dimension);
                }
                catch (e) { }
            }
        }
    }
}
