import { DamageItem } from "../libraries/Durability";
import { beforeEvents, getOrientation, getOrientationX } from "../libraries/utils";
const ListTag = [
    "diamond_pick_diggable",
    "stone"
];
const ListID = [
    "minecraft:stonebrick",
    "minecraft:netherrack",
    "minecraft:copper_ore",
    "minecraft:deepslate_copper_ore",
    "minecraft:deepslate"
];
beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry: ItemRegistry }) => {
    ItemRegistry.registerCustomComponent('true_tools:hammer_3x3', {
        onMineBlock: ({ block: b, source: player, itemStack }) => {
            if (player.isPlayer())
                DamageItem(player, itemStack);
            const rot = player.getRotation();
            const oX = getOrientationX(rot.x);
            const oY = getOrientation(rot.y);
            for (let dY = -1; dY <= 1; dY++) {
                for (let dXZ = -1; dXZ <= 1; dXZ++) {
                    if (!dXZ && !dY)
                        continue;
                    let x, y, z;
                    if (oX >= 0) {
                        x = b.x < 0 ? b.x - dY : b.x + dY;
                        y = b.y;
                        z = b.z < 0 ? b.z - dXZ : b.z + dXZ;
                    }
                    else {
                        x = oY >= 3 ? b.x : b.x < 0 ? b.x - dXZ : b.x + dXZ;
                        y = b.y < 0 ? b.y - dY : b.y + dY;
                        z = oY < 3 ? b.z : b.z < 0 ? b.z - dXZ : b.z + dXZ;
                    }
                    const block = b.dimension.getBlock({ x, y, z });
                    if (!block)
                        continue;
                    if (!ListTag.some(t => block.hasTag(t)) && !ListID.some(id => block.permutation.matches(id) && !block.typeId.match(/brick|_wall/)))
                        continue;
                    block.destroy();
                }
            }
        }
    });
});
