import { DamageItem } from "../libraries/Durability";
import { beforeEvents, sleep, Vector } from "../libraries/utils";
const DestroyList = [
    "grass",
    "dirt"
];
const CropInfo = {
    'minecraft:wheat': {
        state: { id: 'growth', value: 7 }
    },
    'minecraft:potatoes': {
        state: { id: 'growth', value: 7 }
    },
    'minecraft:carrots': {
        state: { id: 'growth', value: 7 }
    },
    'minecraft:beetroot': {
        state: { id: 'growth', value: 7 }
    },
};
beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry: ItemRegistry }) => {
    ItemRegistry.registerCustomComponent('true_tools:farmland_3x3', {
        onUseOn: ({ block, usedOnBlockPermutation: old, source, itemStack }) => {
        },
    });
    ItemRegistry.registerCustomComponent('true_tools:harvest_3x3', {
        onMineBlock: ({ source, itemStack, block, minedBlockPermutation: old }) => {
            if (source.isPlayer())
                DamageItem(source, itemStack);
            const { dimension, location } = block;
            const crop = CropInfo[old.type.id];
            if (!crop)
                return;
            const growth = block.permutation.getState(crop.state.id);
            if (growth < crop.state.value)
                return;
            for (let dX = -1; dX <= 1; dX++) {
                for (let dZ = -1; dZ <= 1; dZ++) {
                    const b = dimension.getBlock(Vector.add(location, { x: dX, z: dZ }));
                    if (!b)
                        continue;
                    const crop = CropInfo[b.typeId];
                    if (!crop)
                        continue;
                    const next = block.permutation;
                    const growth = block.permutation.getState(crop.state.id);
                    if (growth < crop.state.value)
                        continue;
                    b.destroy();
                    b.setPermutation(next.withState(crop.state.id, 0));
                }
            }
        },
    });
});
beforeEvents.itemUseOn.subscribe(async ({ source, itemStack: tool, block }) => {
    if (!tool.getTags().includes('true_tools:harvest_3x3'))
        return;
    const { dimension, location } = block;
    const crop = CropInfo[block.typeId];
    if (!crop)
        return;
    const growth = block.permutation.getState(crop.state.id);
    if (growth < crop.state.value)
        return;
    await sleep();
    for (let dX = -1; dX <= 1; dX++) {
        for (let dZ = -1; dZ <= 1; dZ++) {
            const b = dimension.getBlock(Vector.add(location, { x: dX, z: dZ }));
            if (!b)
                continue;
            const crop = CropInfo[b.typeId];
            if (!crop)
                continue;
            const next = b.permutation;
            const growth = b.permutation.getState(crop.state.id);
            if (growth < crop.state.value)
                continue;
            b.destroy();
            b.setPermutation(next.withState(crop.state.id, 0));
        }
    }
    DamageItem(source, tool);
});
beforeEvents.itemUseOn.subscribe(async (data) => {
    const { source, itemStack: tool, block } = data;
    if (!tool.getTags().includes('true_tools:farmland_3x3') || !block.hasTag('grass'))
        return;
    const { dimension, location } = block;
    data.cancel = true;
    await sleep();
    dimension.playSound('step.gravel', location);
    for (let dX = -1; dX <= 1; dX++) {
        for (let dZ = -1; dZ <= 1; dZ++) {
            const b = dimension.getBlock(Vector.add(location, { x: dX, z: dZ }));
            if (!DestroyList.some(t => b?.hasTag(t)))
                continue;
            b?.setType('minecraft:farmland');
        }
    }
    if (source.isPlayer())
        DamageItem(source, tool);
});
