import { beforeEvents, sleep } from "../libraries/utils";
import { DamageItem } from "../libraries/Durability";
beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry: ItemRegistry }) => {
    ItemRegistry.registerCustomComponent('true_tools:shears', {
        onMineBlock: ({ source, itemStack, block, minedBlockPermutation: old }) => {
            if (source.isPlayer())
                DamageItem(source, itemStack);
            if (!old.type.id.includes('leaves'))
                return;
            const { location, dimension } = block;
            getNearbyBlocks(location, dimension, async function cb(b) {
                if (!b.typeId.includes('leaves'))
                    return;
                const drop = b.getItemStack();
                b.destroy(!drop);
                if (drop)
                    dimension.spawnItem(drop, b.center());
                await sleep();
                getNearbyBlocks(b, dimension, cb);
            });
        }
    });
});
export async function getNearbyBlocks(pos, dimension, cb) {
    for (let x = pos.x - 1; x <= pos.x + 1; x++) {
        for (let y = pos.y - 1; y <= pos.y + 1; y++) {
            for (let z = pos.z - 1; z <= pos.z + 1; z++) {
                try {
                    const block = dimension.getBlock({ x, y, z });
                    if (block)
                        cb(block, dimension);
                }
                catch (e) { }
            }
        }
    }
}
