import { DamageItem } from "../libraries/Durability";
import { beforeEvents, getOrientation, getOrientationX, sleep, Vector } from "../libraries/utils";
const DestroyList = [
    "grass",
    "gravel",
    "dirt",
    "snow",
    "sand"
];
beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry: ItemRegistry }) => {
    ItemRegistry.registerCustomComponent('true_tools:shovel_3x3', {
        onUseOn: () => { },
        onMineBlock: ({ block: b, source: player, itemStack: tool }) => {
            if (player.isPlayer())
                DamageItem(player, tool);
            const rot = player.getRotation();
            const oX = getOrientationX(rot.x);
            const oY = getOrientation(rot.y);
            for (let dY = -1; dY <= 1; dY++) {
                for (let dXZ = -1; dXZ <= 1; dXZ++) {
                    if (!dXZ && !dY)
                        continue;
                    let x, y, z;
                    if (oX >= 0) {
                        x = b.x < 0 ? b.x - dY : b.x + dY;
                        y = b.y;
                        z = b.z < 0 ? b.z - dXZ : b.z + dXZ;
                    }
                    else {
                        x = oY >= 3 ? b.x : b.x < 0 ? b.x - dXZ : b.x + dXZ;
                        y = b.y < 0 ? b.y - dY : b.y + dY;
                        z = oY < 3 ? b.z : b.z < 0 ? b.z - dXZ : b.z + dXZ;
                    }
                    const block = b.dimension.getBlock({ x, y, z });
                    if (!block)
                        continue;
                    if (!DestroyList.some(t => block.hasTag(t)) && block.typeId !== 'minecraft:snow')
                        continue;
                    block.destroy();
                }
            }
        },
    });
});
beforeEvents.itemUseOn.subscribe(async (data) => {
    const { block, source, itemStack: tool } = data;
    if (!tool.getTags().includes('true_tools:grass_path_3x3') || !block.hasTag('dirt'))
        return;
    data.cancel = true;
    await sleep();
    const { dimension, location } = block;
    dimension.playSound('step.grass', location);
    for (let dX = -1; dX <= 1; dX++) {
        for (let dZ = -1; dZ <= 1; dZ++) {
            const b = dimension.getBlock(Vector.add(location, { x: dX, z: dZ }));
            if (!b?.hasTag('dirt'))
                continue;
            b?.setType('minecraft:grass_path');
        }
    }
    DamageItem(source, tool);
});
